## ngtcp2 1.5.0

=== debian/changelog ===
ngtcp2 (1.5.0-2) sid; urgency=medium

  * Uploading to sid.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 28 Jun 2024 17:46:38 +0200

ngtcp2 (1.5.0-1) experimental; urgency=medium

  * New upstream version 1.5.0.
  * d/copyright: Updated for new version.
  * d/control
    - Changed Build-Depends from pkg-config to pkgconf.
    - Added Debian Curl Maintainers as Maintainer.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sun, 12 May 2024 20:03:53 +0200

ngtcp2 (1.1.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.1.0.
  * Renamed d/libngtcp2-15.install to d/libngtcp2-16.install.
  * Renamed d/libngtcp2-crypto-gnutls7.install to
    d/libngtcp2-crypto-gnutls8.install.
  * d/control:
    - Updated binary packages name because of soname bump.
    - Updated build-depends and depends because of soname bump.
  * Removed d/libngtcp2-15.symbols and d/libngtcp2-crypto-gnutls7.symbols.
  * Added d/libngtcp2-16.symbols and d/libngtcp2-crypto-gnutls8.symbols.
  * d/changelog:
    - Correcting 0.19.1-1 Standards-Version was not updated.
    - Correcting 0.19.1-1 d/README.source was not removed.
  * Removed d/README.source because js-minfied code was removed.
  * d/copyright: Adding copyright changes and update year from d/*.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 08 Jan 2024 16:34:04 +0100

ngtcp2 (0.19.1-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.19.1.
  * Renamed d/libngtcp2-9.install to d/libngtcp2-15.install.
  * Renamed d/libngtcp2-crypto-gnutls2.install to
    d/libngtcp2-crypto-gnutls7.install.
  * d/control:
    - Updated binary packages name because of soname bump.
    - Updated build-depends and depends because of soname bump.
  * Removed d/libngtcp2-9.symbols and d/libngtcp2-crypto-gnutls2.symbols.
  * Added d/libngtcp2-15.symbols and d/libngtcp2-crypto-gnutls7.symbols.
  * d/copyright: Remove Files-Excluded because js-minfied code was removed.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 08 Sep 2023 13:37:28 +0200

## ngtcp2 1.6.0

=== debian/changelog ===
ngtcp2 (1.6.0-1) sid; urgency=medium

  * New upstream version 1.6.0.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Thu, 25 Jul 2024 11:55:21 +0200

=== debian/control ===
Source: ngtcp2
Section: libs
Priority: optional
Maintainer: Debian Curl Maintainers <team+curl@tracker.debian.org>
Uploaders:
 Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends:
 chrpath,
 debhelper-compat (= 13),
 libcunit1-dev,
 libev-dev,
 libgnutls28-dev (>= 3.7.2),
 libnghttp3-dev (>= 1.1.0),
 pkgconf,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/ngtcp2/ngtcp2
Vcs-Browser: https://salsa.debian.org/saki/ngtcp2
Vcs-Git: https://salsa.debian.org/saki/ngtcp2.git

Package: libngtcp2-16
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-crypto-gnutls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngtcp2-crypto-gnutls8 (= ${binary:Version}),
 ${misc:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: libngtcp2-crypto-gnutls8
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ${misc:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: ngtcp2-client
Architecture: any
Multi-Arch: foreign
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp2 client.

Package: ngtcp2-server
Architecture: any
Multi-Arch: foreign
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ssl-cert,
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp server.

## ngtcp2 1.9.1

=== debian/changelog ===
ngtcp2 (1.9.1-1~bpo12+1) bookworm-backports; urgency=medium

  * Team upload.
  * Rebuild for bookworm-backports.

 -- Matheus Polkorny <mpolkorny@gmail.com>  Mon, 02 Dec 2024 19:10:21 -0300

ngtcp2 (1.9.1-1) sid; urgency=medium

  * New upstream version 1.9.1.
    - Fix CVE-2024-52811 qlog buffer overflow.
  * d/libngtcp2-crypto-gnutls8.symbols: Adding new symbols.
  * d/copyright: Updating authors.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Tue, 26 Nov 2024 17:35:47 +0100

ngtcp2 (1.6.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Team upload.
  * Rebuild for bookworm-backports.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 11 Aug 2024 12:31:23 +0100

## ngtcp2 1.11.0

=== CMakeLists.txt ===
# ngtcp2
#
# Copyright (c) 2016 ngtcp2 contributors
# Copyright (c) 2012 nghttp2 contributors
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 3.20)

# Allow setting VISIBILITY_PRESET on static library targets without warning.
cmake_policy(SET CMP0063 NEW)

# XXX using 0.1.90 instead of 0.2.0-DEV
project(ngtcp2 VERSION 1.11.0)

# See versioning rule:
#  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(LT_CURRENT  18)
set(LT_REVISION 9)
set(LT_AGE      2)

set(CRYPTO_QUICTLS_LT_CURRENT 5)
set(CRYPTO_QUICTLS_LT_REVISION 0)
set(CRYPTO_QUICTLS_LT_AGE 3)

set(CRYPTO_GNUTLS_LT_CURRENT 10)
set(CRYPTO_GNUTLS_LT_REVISION 0)
set(CRYPTO_GNUTLS_LT_AGE 2)

set(CRYPTO_WOLFSSL_LT_CURRENT 7)
set(CRYPTO_WOLFSSL_LT_REVISION 0)
set(CRYPTO_WOLFSSL_LT_AGE 2)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
include(Version)

math(EXPR LT_SOVERSION "${LT_CURRENT} - ${LT_AGE}")
set(LT_VERSION "${LT_SOVERSION}.${LT_AGE}.${LT_REVISION}")

math(EXPR CRYPTO_QUICTLS_LT_SOVERSION
  "${CRYPTO_QUICTLS_LT_CURRENT} - ${CRYPTO_QUICTLS_LT_AGE}")
set(CRYPTO_QUICTLS_LT_VERSION
  "${CRYPTO_QUICTLS_LT_SOVERSION}.${CRYPTO_QUICTLS_LT_AGE}.${CRYPTO_QUICTLS_LT_REVISION}")

math(EXPR CRYPTO_GNUTLS_LT_SOVERSION
  "${CRYPTO_GNUTLS_LT_CURRENT} - ${CRYPTO_GNUTLS_LT_AGE}")
set(CRYPTO_GNUTLS_LT_VERSION
  "${CRYPTO_GNUTLS_LT_SOVERSION}.${CRYPTO_GNUTLS_LT_AGE}.${CRYPTO_GNUTLS_LT_REVISION}")

math(EXPR CRYPTO_WOLFSSL_LT_SOVERSION
  "${CRYPTO_WOLFSSL_LT_CURRENT} - ${CRYPTO_WOLFSSL_LT_AGE}")
set(CRYPTO_WOLFSSL_LT_VERSION
  "${CRYPTO_WOLFSSL_LT_SOVERSION}.${CRYPTO_WOLFSSL_LT_AGE}.${CRYPTO_WOLFSSL_LT_REVISION}")

set(PACKAGE_VERSION     "${PROJECT_VERSION}")
HexVersion(PACKAGE_VERSION_NUM ${PROJECT_VERSION_MAJOR} ${PROJECT_VERSION_MINOR} ${PROJECT_VERSION_PATCH})

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build type" FORCE)

  # Include "None" as option to disable any additional (optimization) flags,
  # relying on just CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (which are empty by
  # default). These strings are presented in cmake-gui.
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)
include(CMakeDependentOption)

include(CMakeOptions.txt)

# Do not disable assertions based on CMAKE_BUILD_TYPE.
foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
  foreach(_lang C CXX)
    string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " " ${_var} "${${_var}}")
  endforeach()
endforeach()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

include(CMakePushCheckState)

if(NOT CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_ASAN)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
    check_c_compiler_flag(-fsanitize=address C__fsanitize_address_VALID)
    check_cxx_compiler_flag(-fsanitize=address CXX__fsanitize_address_VALID)
    cmake_pop_check_state()
    if(NOT C__fsanitize_address_VALID OR NOT CXX__fsanitize_address_VALID)
      message(WARNING "ENABLE_ASAN was requested, but not supported!")
    else()
      set(CMAKE_C_FLAGS "-fsanitize=address ${CMAKE_C_FLAGS}")
      set(CMAKE_CXX_FLAGS "-fsanitize=address ${CMAKE_CXX_FLAGS}")
    endif()
  endif()
endif()

if(ENABLE_GNUTLS)
  find_package(GnuTLS 3.7.2 REQUIRED)
endif()
if(ENABLE_OPENSSL OR ENABLE_PICOTLS)
  find_package(OpenSSL 1.1.1 REQUIRED)
endif()
if(ENABLE_WOLFSSL)
  find_package(wolfssl 5.5.0 REQUIRED)
endif()
if(ENABLE_JEMALLOC)
  find_package(Jemalloc REQUIRED)
endif()
find_package(Libev 4.11)
find_package(Libnghttp3 1.0.0)
find_package(Libbrotlienc 1.0.9)
find_package(Libbrotlidec 1.0.9)
enable_testing()
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

# OpenSSL (required for libngtcp2_crypto_quictls,
# libngtcp2_crypto_picotls and examples)
include(CheckSymbolExists)
if(OPENSSL_FOUND)
  set(VANILLA_OPENSSL_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
  set(VANILLA_OPENSSL_LIBRARIES ${OPENSSL_LIBRARIES})
  set(HAVE_VANILLA_OPENSSL TRUE)

  # Until OpenSSL gains mainline support for QUIC, check for a patched version.
  if(ENABLE_OPENSSL)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_INCLUDES   "${OPENSSL_INCLUDE_DIR}")
    set(CMAKE_REQUIRED_LIBRARIES  "${OPENSSL_LIBRARIES}")
    if(WIN32)
      set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}" "ws2_32" "bcrypt")
    endif()
    check_symbol_exists(SSL_provide_quic_data "openssl/ssl.h" HAVE_SSL_PROVIDE_QUIC_DATA)
    if(NOT HAVE_SSL_PROVIDE_QUIC_DATA)
      message(FATAL_ERROR "Unable to build OpenSSL backend due to lack of QUIC support in ${OPENSSL_LIBRARIES}")
    endif()
    cmake_pop_check_state()
  endif()
endif()
if(ENABLE_OPENSSL)
  set(OPENSSL_INCLUDE_DIRS  ${OPENSSL_INCLUDE_DIR})
  set(HAVE_OPENSSL TRUE)
  set(HAVE_CRYPTO TRUE)
else()
  set(HAVE_OPENSSL FALSE)
  set(OPENSSL_INCLUDE_DIRS  "")
  set(OPENSSL_LIBRARIES     "")
endif()

# BoringSSL (required for libngtcp2_crypto_boringssl)
include(CheckCXXSymbolExists)
if(ENABLE_BORINGSSL)
  cmake_push_check_state()
  set(CMAKE_REQUIRED_INCLUDES   "${BORINGSSL_INCLUDE_DIR}")
  set(CMAKE_REQUIRED_LIBRARIES  "${BORINGSSL_LIBRARIES}")
  check_cxx_symbol_exists(SSL_set_quic_early_data_context "openssl/ssl.h" HAVE_SSL_SET_QUIC_EARLY_DATA_CONTEXT)
  if(NOT HAVE_SSL_SET_QUIC_EARLY_DATA_CONTEXT)
    message(FATAL_ERROR "Unable to build BoringSSL backend due to lack of QUIC support in ${BORINGSSL_LIBRARIES}")
  endif()
  cmake_pop_check_state()
endif()
if(ENABLE_BORINGSSL)
  set(BORINGSSL_INCLUDE_DIRS  ${BORINGSSL_INCLUDE_DIR})
  set(HAVE_BORINGSSL TRUE)
  set(HAVE_CRYPTO TRUE)
else()
  set(HAVE_BORINGSSL FALSE)
  set(BORINGSSL_INCLUDE_DIRS  "")
  set(BORINGSSL_LIBRARIES     "")
endif()

# jemalloc
set(HAVE_JEMALLOC ${JEMALLOC_FOUND})
# libev (required for examples)
set(HAVE_LIBEV      ${LIBEV_FOUND})
# libnghttp3 (required for examples)
set(HAVE_LIBNGHTTP3 ${LIBNGHTTP3_FOUND})

# GnuTLS (required for libngtcp2_crypto_gnutls)
if(ENABLE_GNUTLS)
  set(GNUTLS_INCLUDE_DIRS  ${GNUTLS_INCLUDE_DIR})
  set(HAVE_GNUTLS TRUE)
  set(HAVE_CRYPTO TRUE)
else()
  set(HAVE_GNUTLS FALSE)
  set(GNUTLS_INCLUDE_DIRS  "")
  set(GNUTLS_LIBRARIES     "")
endif()

# Picotls (required for libngtcp2_crypto_picotls)
if(ENABLE_PICOTLS)
  cmake_push_check_state()
  set(CMAKE_REQUIRED_INCLUDES   "${PICOTLS_INCLUDE_DIR}" "${VANILLA_OPENSSL_INCLUDE_DIRS}")
  set(CMAKE_REQUIRED_LIBRARIES  "${PICOTLS_LIBRARIES}" "${VANILLA_OPENSSL_LIBRARIES}")
  check_symbol_exists(ptls_openssl_random_bytes "picotls.h;picotls/openssl.h"
    HAVE_PTLS_OPENSSL_RANDOM_BYTES)
  if(NOT HAVE_PTLS_OPENSSL_RANDOM_BYTES)
    message(FATAL_ERROR "Unable to build Picotls backend because ptls_openssl_random_bytes not found in ${CMAKE_REQUIRED_LIBRARIES}")
  endif()
  cmake_pop_check_state()
endif()
if(ENABLE_PICOTLS)
  set(PICOTLS_INCLUDE_DIRS  ${PICOTLS_INCLUDE_DIR})
  set(HAVE_PICOTLS TRUE)
  set(HAVE_CRYPTO TRUE)
else()
  set(HAVE_PICOTLS FALSE)
  set(PICOTLS_INCLUDE_DIRS  "")
  set(PICOTLS_LIBRARIES     "")
endif()

# wolfSSL (required for libngtcp2_crypto_wolfssl)
if(ENABLE_WOLFSSL)
  set(WOLFSSL_INCLUDE_DIRS  ${WOLFSSL_INCLUDE_DIR})
  set(HAVE_WOLFSSL TRUE)
  set(HAVE_CRYPTO TRUE)
else()
  set(HAVE_WOLFSSL FALSE)
  set(WOLFSSL_INCLUDE_DIRS  "")
  set(WOLFSSL_LIBRARIES     "")
endif()

# libbrotli (required for certificate compression)
set(HAVE_LIBBROTLIENC ${LIBBROTLIENC_FOUND})
set(HAVE_LIBBROTLIDEC ${LIBBROTLIDEC_FOUND})
if(LIBBROTLIENC_FOUND AND LIBBROTLIDEC_FOUND)
  set(HAVE_LIBBROTLI 1)
endif()

# Checks for header files.
include(CheckIncludeFile)
check_include_file("arpa/inet.h"   HAVE_ARPA_INET_H)
check_include_file("netinet/in.h"  HAVE_NETINET_IN_H)
check_include_file("netinet/ip.h"  HAVE_NETINET_IP_H)
check_include_file("unistd.h"      HAVE_UNISTD_H)
check_include_file("sys/endian.h"  HAVE_SYS_ENDIAN_H)
check_include_file("endian.h"      HAVE_ENDIAN_H)
check_include_file("byteswap.h"    HAVE_BYTESWAP_H)
check_include_file("asm/types.h"   HAVE_ASM_TYPES_H)
check_include_file("linux/netlink.h"   HAVE_LINUX_NETLINK_H)
check_include_file("linux/rtnetlink.h" HAVE_LINUX_RTNETLINK_H)

include(CheckTypeSize)
# Checks for typedefs, structures, and compiler characteristics.
# AC_TYPE_SIZE_T
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to a pointer-size int.
  set(ssize_t ptrdiff_t)
endif()

# Checks for symbols.
if(HAVE_ENDIAN_H)
  check_symbol_exists(be64toh "endian.h" HAVE_DECL_BE64TOH)
endif()
if(NOT HAVE_DECL_BE64TOH AND HAVE_SYS_ENDIAN_H)
  check_symbol_exists(be64toh "sys/endian.h" HAVE_DECL_BE64TOH)
endif()

check_symbol_exists(bswap_64 "byteswap.h" HAVE_DECL_BSWAP_64)
check_symbol_exists(explicit_bzero "string.h" HAVE_EXPLICIT_BZERO)
check_symbol_exists(memset_s "string.h" HAVE_MEMSET_S)

if(${CMAKE_C_BYTE_ORDER} STREQUAL "BIG_ENDIAN")
  set(WORDS_BIGENDIAN 1)
endif()

set(WARNCFLAGS)
set(WARNCXXFLAGS)
if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_WERROR)
    set(WARNCFLAGS    /WX)
    set(WARNCXXFLAGS  /WX)
  endif()
else()
  if(ENABLE_WERROR)
    set(WARNCFLAGS   "-Werror")
    set(WARNCXXFLAGS "-Werror")
  endif()

  include(PickyWarningsC)
  include(PickyWarningsCXX)
endif()

if(ENABLE_DEBUG)
  set(DEBUGBUILD 1)
endif()

add_definitions(-DHAVE_CONFIG_H)
configure_file(cmakeconfig.h.in config.h)
# autotools-compatible names
# Sphinx expects relative paths in the .rst files. Use the fact that the files
# below are all one directory level deep.
file(RELATIVE_PATH top_srcdir   "${CMAKE_CURRENT_BINARY_DIR}/dir" "${CMAKE_CURRENT_SOURCE_DIR}")
file(RELATIVE_PATH top_builddir "${CMAKE_CURRENT_BINARY_DIR}/dir" "${CMAKE_CURRENT_BINARY_DIR}")
set(abs_top_srcdir  "${CMAKE_CURRENT_SOURCE_DIR}")
set(abs_top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
# libngtcp2.pc (pkg-config file)
set(prefix          "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix     "${CMAKE_INSTALL_PREFIX}")
set(libdir          "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir      "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(VERSION         "${PACKAGE_VERSION}")
# For init scripts and systemd service file (in contrib/)
set(bindir          "${CMAKE_INSTALL_FULL_BINDIR}")
set(sbindir         "${CMAKE_INSTALL_FULL_SBINDIR}")
foreach(name
  lib/libngtcp2.pc
  lib/includes/ngtcp2/version.h
)
  configure_file("${name}.in" "${name}" @ONLY)
endforeach()

if(APPLE)
  add_definitions(-D__APPLE_USE_RFC_3542)
endif()

if(ENABLE_SHARED_LIB AND ENABLE_STATIC_LIB AND MSVC AND NOT STATIC_LIB_SUFFIX)
  set(STATIC_LIB_SUFFIX "_static")
endif()

include_directories(
  "${CMAKE_CURRENT_BINARY_DIR}" # for config.h
)
# For use in src/CMakeLists.txt
set(PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")

install(FILES README.rst DESTINATION "${CMAKE_INSTALL_DOCDIR}")

add_subdirectory(lib)
if(BUILD_TESTING)

=== crypto/CMakeLists.txt ===
# ngtcp2

# Copyright (c) 2019 ngtcp2

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(HAVE_CRYPTO)
  add_subdirectory(includes)
endif()

if(HAVE_OPENSSL)
  add_subdirectory(quictls)
elseif(ENABLE_OPENSSL)
  message(WARNING "libngtcp2_crypto_quictls library is disabled due to lack of good quictls")
endif()

if(HAVE_GNUTLS)
  add_subdirectory(gnutls)
elseif(ENABLE_GNUTLS)
  message(WARNING "libngtcp2_crypto_gnutls library is disabled due to lack of good GnuTLS")
endif()

if(HAVE_BORINGSSL)
  add_subdirectory(boringssl)
elseif(ENABLE_BORINGSSL)
  message(WARNING "libngtcp2_crypto_boringssl library is disabled due to lack of good BoringSSL")
endif()

if(HAVE_PICOTLS)
  add_subdirectory(picotls)
elseif(ENABLE_PICOTLS)
  message(WARNING "libngtcp2_crypto_picotls library is disabled due to lack of good Picotls")
endif()

if(HAVE_WOLFSSL)
  add_subdirectory(wolfssl)
elseif(ENABLE_WOLFSSL)
  message(WARNING "libngtcp2_crypto_wolfssl library is disabled due to lack of good wolfSSL")
endif()

=== examples/CMakeLists.txt ===
# ngtcp2

# Copyright (c) 2017 ngtcp2 contributors

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(LIBEV_FOUND AND HAVE_OPENSSL AND LIBNGHTTP3_FOUND)
  set(qtlsclient_SOURCES
    client.cc
    client_base.cc
    debug.cc
    util.cc
    shared.cc
    tls_client_context_quictls.cc
    tls_client_session_quictls.cc
    tls_session_base_quictls.cc
    util_openssl.cc
  )

  set(qtlsserver_SOURCES
    server.cc
    server_base.cc
    debug.cc
    util.cc
    http.cc
    shared.cc
    siphash.cc
    tls_server_context_quictls.cc
    tls_server_session_quictls.cc
    tls_session_base_quictls.cc
    util_openssl.cc
  )

  set(qtls_INCLUDE_DIRS
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/third-party
    ${CMAKE_SOURCE_DIR}/third-party/urlparse
    ${CMAKE_SOURCE_DIR}/crypto/includes

    ${JEMALLOC_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIRS}
    ${LIBEV_INCLUDE_DIRS}
    ${LIBNGHTTP3_INCLUDE_DIRS}
  )

  set(qtls_LIBS
    ngtcp2_crypto_quictls
    ngtcp2
    ${JEMALLOC_LIBRARIES}
    ${OPENSSL_LIBRARIES}
    ${LIBEV_LIBRARIES}
    ${LIBNGHTTP3_LIBRARIES}
  )

  add_executable(qtlsclient ${qtlsclient_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  add_executable(qtlsserver ${qtlsserver_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  set_target_properties(qtlsclient PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_QUICTLS -DWITH_EXAMPLE_QUICTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  set_target_properties(qtlsserver PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_QUICTLS -DWITH_EXAMPLE_QUICTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  target_include_directories(qtlsclient PUBLIC ${qtls_INCLUDE_DIRS})
  target_include_directories(qtlsserver PUBLIC ${qtls_INCLUDE_DIRS})
  target_link_libraries(qtlsclient ${qtls_LIBS})
  target_link_libraries(qtlsserver ${qtls_LIBS})

  # TODO prevent client and example servers from being installed?
endif()

if(LIBEV_FOUND AND HAVE_GNUTLS AND LIBNGHTTP3_FOUND)
  set(gtlsclient_SOURCES
    client.cc
    client_base.cc
    debug.cc
    util.cc
    shared.cc
    tls_client_context_gnutls.cc
    tls_client_session_gnutls.cc
    tls_session_base_gnutls.cc
    util_gnutls.cc
  )

  set(gtlsserver_SOURCES
    server.cc
    server_base.cc
    debug.cc
    util.cc
    http.cc
    shared.cc
    siphash.cc
    tls_server_context_gnutls.cc
    tls_server_session_gnutls.cc
    tls_session_base_gnutls.cc
    util_gnutls.cc
  )

  set(gtls_INCLUDE_DIRS
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/third-party
    ${CMAKE_SOURCE_DIR}/third-party/urlparse
    ${CMAKE_SOURCE_DIR}/crypto/includes

    ${JEMALLOC_INCLUDE_DIRS}
    ${GNUTLS_INCLUDE_DIRS}
    ${LIBEV_INCLUDE_DIRS}
    ${LIBNGHTTP3_INCLUDE_DIRS}
  )

  set(gtls_LIBS
    ngtcp2_crypto_gnutls
    ngtcp2
    ${JEMALLOC_LIBRARIES}
    ${GNUTLS_LIBRARIES}
    ${LIBEV_LIBRARIES}
    ${LIBNGHTTP3_LIBRARIES}
  )

  add_executable(gtlsclient ${gtlsclient_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  add_executable(gtlsserver ${gtlsserver_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  set_target_properties(gtlsclient PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_GNUTLS -DWITH_EXAMPLE_GNUTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  set_target_properties(gtlsserver PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_GNUTLS -DWITH_EXAMPLE_GNUTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  target_include_directories(gtlsclient PUBLIC ${gtls_INCLUDE_DIRS})
  target_include_directories(gtlsserver PUBLIC ${gtls_INCLUDE_DIRS})
  target_link_libraries(gtlsclient ${gtls_LIBS})
  target_link_libraries(gtlsserver ${gtls_LIBS})

  # TODO prevent gtlsclient and example gtlsservers from being installed?
endif()

if(LIBEV_FOUND AND HAVE_BORINGSSL AND LIBNGHTTP3_FOUND)
  set(bsslclient_SOURCES
    client.cc
    client_base.cc
    debug.cc
    util.cc
    shared.cc
    tls_client_context_boringssl.cc
    tls_client_session_boringssl.cc
    tls_session_base_quictls.cc
    tls_shared_boringssl.cc
    util_openssl.cc
  )

  set(bsslserver_SOURCES
    server.cc
    server_base.cc
    debug.cc
    util.cc
    http.cc
    shared.cc
    siphash.cc
    tls_server_context_boringssl.cc
    tls_server_session_boringssl.cc
    tls_session_base_quictls.cc
    tls_shared_boringssl.cc
    util_openssl.cc
  )

  set(bssl_INCLUDE_DIRS
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/third-party
    ${CMAKE_SOURCE_DIR}/third-party/urlparse
    ${CMAKE_SOURCE_DIR}/crypto/includes

    ${JEMALLOC_INCLUDE_DIRS}
    ${BORINGSSL_INCLUDE_DIRS}
    ${LIBEV_INCLUDE_DIRS}
    ${LIBNGHTTP3_INCLUDE_DIRS}
    ${LIBBROTLIENC_INCLUDE_DIRS}
    ${LIBBROTLIDEC_INCLUDE_DIRS}
  )

  set(bssl_LIBS
    ngtcp2_crypto_boringssl_static
    ngtcp2
    ${JEMALLOC_LIBRARIES}
    ${BORINGSSL_LIBRARIES}
    ${LIBEV_LIBRARIES}
    ${LIBNGHTTP3_LIBRARIES}
    ${LIBBROTLIENC_LIBRARIES}
    ${LIBBROTLIDEC_LIBRARIES}
  )

  add_executable(bsslclient ${bsslclient_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  add_executable(bsslserver ${bsslserver_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  set_target_properties(bsslclient PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_BORINGSSL -DWITH_EXAMPLE_BORINGSSL"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  set_target_properties(bsslserver PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_BORINGSSL -DWITH_EXAMPLE_BORINGSSL"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  target_include_directories(bsslclient PUBLIC ${bssl_INCLUDE_DIRS})
  target_include_directories(bsslserver PUBLIC ${bssl_INCLUDE_DIRS})
  target_link_libraries(bsslclient ${bssl_LIBS})
  target_link_libraries(bsslserver ${bssl_LIBS})

  # TODO prevent bsslclient and example bsslservers from being installed?
endif()

if(LIBEV_FOUND AND HAVE_PICOTLS AND LIBNGHTTP3_FOUND)
  set(ptlsclient_SOURCES
    client.cc
    client_base.cc
    debug.cc
    util.cc
    shared.cc
    tls_client_context_picotls.cc
    tls_client_session_picotls.cc
    tls_session_base_picotls.cc
    tls_shared_picotls.cc
    util_openssl.cc
  )

  set(ptlsserver_SOURCES
    server.cc
    server_base.cc
    debug.cc
    util.cc
    http.cc
    shared.cc
    siphash.cc
    tls_server_context_picotls.cc
    tls_server_session_picotls.cc
    tls_session_base_picotls.cc
    tls_shared_picotls.cc
    util_openssl.cc
  )

  set(ptls_INCLUDE_DIRS
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/third-party
    ${CMAKE_SOURCE_DIR}/third-party/urlparse
    ${CMAKE_SOURCE_DIR}/crypto/includes

    ${JEMALLOC_INCLUDE_DIRS}
    ${PICOTLS_INCLUDE_DIRS}
    ${VANILLA_OPENSSL_INCLUDE_DIRS}
    ${LIBEV_INCLUDE_DIRS}
    ${LIBNGHTTP3_INCLUDE_DIRS}
  )

  set(ptls_LIBS
    ngtcp2_crypto_picotls_static
    ngtcp2
    ${JEMALLOC_LIBRARIES}
    ${PICOTLS_LIBRARIES}
    ${VANILLA_OPENSSL_LIBRARIES}
    ${LIBEV_LIBRARIES}
    ${LIBNGHTTP3_LIBRARIES}
  )

  add_executable(ptlsclient ${ptlsclient_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  add_executable(ptlsserver ${ptlsserver_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  set_target_properties(ptlsclient PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_PICOTLS -DWITH_EXAMPLE_PICOTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  set_target_properties(ptlsserver PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_PICOTLS -DWITH_EXAMPLE_PICOTLS"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  target_include_directories(ptlsclient PUBLIC ${ptls_INCLUDE_DIRS})
  target_include_directories(ptlsserver PUBLIC ${ptls_INCLUDE_DIRS})
  target_link_libraries(ptlsclient ${ptls_LIBS})
  target_link_libraries(ptlsserver ${ptls_LIBS})

  # TODO prevent ptlsclient and example ptlsservers from being installed?
endif()

if(LIBEV_FOUND AND HAVE_WOLFSSL AND LIBNGHTTP3_FOUND)
  set(wsslclient_SOURCES
    client.cc
    client_base.cc
    debug.cc
    util.cc
    shared.cc
    tls_client_context_wolfssl.cc
    tls_client_session_wolfssl.cc
    tls_session_base_wolfssl.cc
    util_wolfssl.cc
  )

  set(wsslserver_SOURCES
    server.cc
    server_base.cc
    debug.cc
    util.cc
    http.cc
    shared.cc
    siphash.cc
    tls_server_context_wolfssl.cc
    tls_server_session_wolfssl.cc
    tls_session_base_wolfssl.cc
    util_wolfssl.cc
  )

  set(wolfssl_INCLUDE_DIRS
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
    ${CMAKE_SOURCE_DIR}/third-party
    ${CMAKE_SOURCE_DIR}/third-party/urlparse
    ${CMAKE_SOURCE_DIR}/crypto/includes

    ${JEMALLOC_INCLUDE_DIRS}
    ${WOLFSSL_INCLUDE_DIRS}
    ${LIBEV_INCLUDE_DIRS}
    ${LIBNGHTTP3_INCLUDE_DIRS}
  )

  set(wolfssl_LIBS
    ngtcp2_crypto_wolfssl_static
    ngtcp2
    ${JEMALLOC_LIBRARIES}
    ${WOLFSSL_LIBRARIES}
    ${LIBEV_LIBRARIES}
    ${LIBNGHTTP3_LIBRARIES}
  )

  add_executable(wsslclient ${wsslclient_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  add_executable(wsslserver ${wsslserver_SOURCES}
    $<TARGET_OBJECTS:urlparse>
  )
  set_target_properties(wsslclient PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_WOLFSSL -DWITH_EXAMPLE_WOLFSSL"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  set_target_properties(wsslserver PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS} -DENABLE_EXAMPLE_WOLFSSL -DWITH_EXAMPLE_WOLFSSL"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
  )
  target_include_directories(wsslclient PUBLIC ${wolfssl_INCLUDE_DIRS})
  target_include_directories(wsslserver PUBLIC ${wolfssl_INCLUDE_DIRS})
  target_link_libraries(wsslclient ${wolfssl_LIBS})
  target_link_libraries(wsslserver ${wolfssl_LIBS})

  # TODO prevent wsslclient and example wsslserver from being installed?
endif()

=== crypto/includes/CMakeLists.txt ===
# ngtcp2

# Copyright (c) 2019 ngtcp2

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

install(FILES
    ngtcp2/ngtcp2_crypto.h
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")

if(HAVE_OPENSSL)
  install(FILES
      ngtcp2/ngtcp2_crypto_quictls.h
      DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")
endif()

if(HAVE_GNUTLS)
  install(FILES
      ngtcp2/ngtcp2_crypto_gnutls.h
      DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")
endif()

if(HAVE_BORINGSSL)
  install(FILES
      ngtcp2/ngtcp2_crypto_boringssl.h
      DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")
endif()

if(HAVE_PICOTLS)
  install(FILES
      ngtcp2/ngtcp2_crypto_picotls.h
      DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")
endif()

if(HAVE_WOLFSSL)
  install(FILES
      ngtcp2/ngtcp2_crypto_wolfssl.h
      DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ngtcp2")
endif()

=== crypto/picotls/CMakeLists.txt ===
# ngtcp2

# Copyright (c) 2022 ngtcp2

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

add_definitions(-DBUILDING_NGTCP2)

set(ngtcp2_crypto_picotls_SOURCES
  picotls.c
  ../shared.c
)

set(ngtcp2_crypto_picotls_INCLUDE_DIRS
  "${CMAKE_CURRENT_SOURCE_DIR}/../../lib/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/../../lib/includes"
  "${CMAKE_CURRENT_SOURCE_DIR}/../../lib"
  "${CMAKE_CURRENT_SOURCE_DIR}/../../crypto/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/../../crypto/includes"
  "${CMAKE_CURRENT_SOURCE_DIR}/../../crypto"
  "${CMAKE_CURRENT_BINARY_DIR}/../../crypto"
  "${PICOTLS_INCLUDE_DIRS}"
  "${VANILLA_OPENSSL_INCLUDE_DIRS}"
)

foreach(name libngtcp2_crypto_picotls.pc)
  configure_file("${name}.in" "${name}" @ONLY)
endforeach()

if(ENABLE_STATIC_LIB)
  # Public static library
  add_library(ngtcp2_crypto_picotls_static STATIC ${ngtcp2_crypto_picotls_SOURCES})
  set_target_properties(ngtcp2_crypto_picotls_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    ARCHIVE_OUTPUT_NAME ngtcp2_crypto_picotls${STATIC_LIB_SUFFIX}
    C_VISIBILITY_PRESET hidden
  )
  target_compile_definitions(ngtcp2_crypto_picotls_static PUBLIC
    "-DNGTCP2_STATICLIB")
  target_include_directories(ngtcp2_crypto_picotls_static PUBLIC
    ${ngtcp2_crypto_picotls_INCLUDE_DIRS})

  install(TARGETS ngtcp2_crypto_picotls_static
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libngtcp2_crypto_picotls.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
ngtcp2 (1.11.0-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 15 Mar 2025 18:08:43 -0700

ngtcp2 (1.11.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Samuel Henrique <samueloph@debian.org>  Fri, 07 Mar 2025 22:21:21 +0000

ngtcp2 (1.11.0-1) unstable; urgency=medium

  [ Matheus Polkorny ]
  * d/upstream/signing-key.asc: Upstream public key.
  * d/watch: Add debian/watch file.

  [ Sakirnth Nagarasa ]
  * New upstream version 1.11.0.
  * d/gbp.conf: Adding debian/unstable as default branch.
  * d/control: Updating Standards-Version.
  * d/control: Updating Vsc path.
  * d/copyright: Updating years and authors for debian/*.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 01 Mar 2025 14:51:39 +0100

=== debian/control ===
Source: ngtcp2
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Curl Maintainers <team+curl@tracker.debian.org>
Uploaders: Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends: chrpath,
               debhelper-compat (= 13),
               libcunit1-dev,
               libev-dev,
               libgnutls28-dev (>= 3.7.2),
               libnghttp3-dev (>= 1.1.0),
               pkgconf
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/ngtcp2/ngtcp2
Vcs-Browser: https://salsa.debian.org/debian/ngtcp2
Vcs-Git: https://salsa.debian.org/debian/ngtcp2.git

Package: libngtcp2-16
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-crypto-gnutls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libngtcp2-crypto-gnutls8 (= ${binary:Version}), ${misc:Depends}
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: libngtcp2-crypto-gnutls8
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libngtcp2-16 (= ${binary:Version}), ${misc:Depends}
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: ngtcp2-client
Architecture: any
Multi-Arch: foreign
Depends: libngtcp2-16 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp2 client.

Package: ngtcp2-server
Architecture: any
Multi-Arch: foreign
Depends: libngtcp2-16 (= ${binary:Version}),
         ssl-cert,
         ${misc:Depends},
         ${shlibs:Depends}
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp server.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-gnutls

execute_after_dh_prep:
	chrpath -d examples/gtlsserver
	chrpath -d examples/gtlsclient

execute_before_dh_install:
	mkdir -p debian/tmp/usr/sbin debian/tmp/usr/bin debian/tmp/usr/share/ngtcp2d/html
	mv examples/gtlsserver debian/tmp/usr/sbin
	mv examples/gtlsclient debian/tmp/usr/bin

execute_after_dh_install:
	rm -f debian/tmp/usr/lib/*/*.la

override_dh_installsystemd:
	dh_installsystemd --no-restart-after-upgrade --no-stop-on-upgrade --no-start --name ngtcp2d

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## ngtcp2 1.12.0

=== debian/changelog ===
ngtcp2 (1.12.0-1~exp1) experimental; urgency=medium

  * Team upload
  * New upstream version 1.12.0

 -- Samuel Henrique <samueloph@debian.org>  Wed, 16 Apr 2025 22:07:07 +0100

## ngtcp2 1.15.1

=== debian/changelog ===
ngtcp2 (1.15.1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.15.1
  * d/control: Bump B-D libnghttp3-dev to 1.11.0
  * d/libngtcp2-16.symbols: New symbol
    ngtcp2_conn_write_aggregate_pkt_versioned@Base

 -- Samuel Henrique <samueloph@debian.org>  Fri, 05 Sep 2025 19:04:27 +0100

=== debian/control ===
Source: ngtcp2
Section: libs
Priority: optional
Maintainer: Debian Curl Maintainers <team+curl@tracker.debian.org>
Uploaders:
 Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends:
 chrpath,
 debhelper-compat (= 13),
 libcunit1-dev,
 libev-dev,
 libgnutls28-dev (>= 3.7.2),
 libnghttp3-dev (>= 1.11.0),
 pkgconf,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/ngtcp2/ngtcp2
Vcs-Browser: https://salsa.debian.org/debian/ngtcp2
Vcs-Git: https://salsa.debian.org/debian/ngtcp2.git

Package: libngtcp2-16
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-crypto-gnutls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngtcp2-crypto-gnutls8 (= ${binary:Version}),
 ${misc:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: libngtcp2-crypto-gnutls8
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (library)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the shared library.

Package: libngtcp2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ${misc:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the development files.

Package: ngtcp2-client
Architecture: any
Multi-Arch: foreign
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp2 client.

Package: ngtcp2-server
Architecture: any
Multi-Arch: foreign
Depends:
 libngtcp2-16 (= ${binary:Version}),
 ssl-cert,
 ${misc:Depends},
 ${shlibs:Depends},
Description: implementation of QUIC protocol (development)
 ngtcp2 project is an effort to implement QUIC protocol which is
 now being discussed in IETF QUICWG for its standardization.
 .
 This package contains the ngtcp server.
